rem ===================
rem   IRST V1.2
rem ===================
pushd %~dp0
SET  APP_NAME= Intel RST Driver
SET  INF_PATH=%~dp0RST
SET  RETURN_CODE=0
SET  APP_LOG=C:\Windows\logs\iRST.log
SET  inbox_iaAHCIC=
SET  inbox_iaStorAC=
SET  inbox_iaStorSW=
SET  inbox_iaStorSwExt=

IF NOT EXIST C:\Windows\logs\ MD C:\Windows\logs\
REM ===================================
ECHO [%TIME%] == The Installation of %APP_NAME%== > %APP_LOG%

:ChkOEM1
for /f %%i in ( 'dir /b C:\Windows\INF\oem*.inf' ) do call :findinbox %%i
goto :ChkREG

:findinbox
set oemstr=%1
find /i "CatalogFile=iaStorAC.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 SET inbox_iaStorAC=%oemstr%
find /i "CatalogFile=iaAHCIC.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 SET inbox_iaAHCIC=%oemstr%
find /i "CatalogFile=iaStorSW.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 SET inbox_iaStorSW=%oemstr%
find /i "CatalogFile=iaStorSwExt.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 set inbox_iaStorSwExt=%oemstr%
goto :eof

:ChkREG
:: Check Registry first
reg query "HKLM\SYSTEM\ControlSet001\Services\iaStorAC\Parameters\Device\NvmeApstEnabled" >> %APP_LOG% 2>&1
if /i not "%errorlevel%"=="0" goto :Ins_Drv
reg delete "HKLM\SYSTEM\ControlSet001\Services\iaStorAC\Parameters\Device\NvmeApstEnabled" /f >> %APP_LOG% 2>&1
timeout /t 5 /nobreak

:Ins_Drv
REM Run Silent Install Command:

:Ins_iaAHCIC
rem ================ install iaAHCIC.inf ===========================
rem  if more device, please add it
if not exist "%INF_PATH%\iaAHCIC.inf" goto :Ins_iaStorAC
echo "find inf file %INF_PATH%\iaAHCIC.inf, start to install ..." >> %APP_LOG%
start /w devcon.exe update "%INF_PATH%\iaAHCIC.inf" "PCI\VEN_8086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:Ins_iaStorAC
rem ================ install iaStorAC.inf ===========================
rem  if more device, please add it
if not exist "%INF_PATH%\iaStorAC.inf" goto :Ins_iaStorSW
echo "find inf file %INF_PATH%\iaStorAC.inf, start to install ..." >> %APP_LOG%
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_282A&SUBSYS_1D011043" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_282A&SUBSYS_1CF11043" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_282A&SUBSYS_1E411043" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_0975&SUBSYS_85108086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_0975&SUBSYS_84108086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
start /w devcon.exe update "%INF_PATH%\iaStorAC.inf" "PCI\VEN_8086&DEV_F1A8&SUBSYS_390D8086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:Ins_iaStorSW
rem ================ install iaStorSW.inf ===========================
rem  if more device, please add it
if not exist "%INF_PATH%\iaStorSW.inf" goto :Ins_iaStorSwExt
echo "find inf file %INF_PATH%\iaStorSW.inf, start to install ..." >> %APP_LOG%
start /w devcon.exe update "%INF_PATH%\iaStorSW.inf" "PCI\VEN_8086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:Ins_iaStorSwExt
rem ================ install iaStorSwExt.inf ===========================
rem  if more device, please add it
rem  devcon.exe update %INF_PATH%\iaStorSwExt.inf "PCI\VEN_8086"
if not exist "%INF_PATH%\iaStorSW.inf" goto :UN_Drv
echo "find inf file %INF_PATH%\iaStorSW.inf, start to install ..." >> %APP_LOG%
start /w devcon.exe update "%INF_PATH%\iaStorSW.inf" "PCI\VEN_8086" >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:UN_Drv
REM Run Silent UnInstall Command:

:UN_iaAHCIC
rem ================ Uninstall inbox iaAHCIC.inf ===========================
if not defined inbox_iaAHCIC  goto :UN_iaStorAC
echo delete %inbox_iaAHCIC% ... >> %APP_LOG%
start /w devcon.exe -f dp_delete %inbox_iaAHCIC% >> %APP_LOG% 2>&1
if exist C:\Windows\INF\%inbox_iaAHCIC% set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:UN_iaStorAC
rem ================ Uninstall inbox iaStorAC.inf ===========================
if not defined inbox_iaStorAC goto :UN_iaStorSW
echo delete %inbox_iaStorAC% ... >> %APP_LOG%
start /w devcon.exe -f dp_delete %inbox_iaStorAC% >> %APP_LOG% 2>&1
if exist C:\Windows\INF\%inbox_iaStorAC% set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:UN_iaStorSW
rem ================ Uninstall inbox iaStorSW.inf ===========================
if not defined inbox_iaStorSW  goto :UN_iaStorSwExt
echo delete %inbox_iaStorSW% ... >> %APP_LOG%
start /w devcon.exe -f dp_delete %inbox_iaStorSW% >> %APP_LOG% 2>&1
if exist C:\Windows\INF\%inbox_iaStorSW% set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:UN_iaStorSwExt
rem ================ Uninstall inbox iaStorSwExt.inf ===========================
if not defined inbox_iaStorSwExt  goto :END
echo delete %inbox_iaStorSwExt% ... >> %APP_LOG%
start /w devcon.exe -f dp_delete %inbox_iaStorSwExt% >> %APP_LOG% 2>&1
if exist C:\Windows\INF\%inbox_iaStorSwExt% set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%

:END
start /w pnputil -a %INF_PATH%\*.inf -i >> %APP_LOG% 2>&1
if /i not %errorlevel%==0 set RETURN_CODE=1
echo RETURN_CODE is %errorlevel%  >> %APP_LOG%
popd
exit /b %RETURN_CODE%